net.sourceforge.pmd.lang.java.rule.basic

## Class AvoidBranchingStatementAsLastInLoopRule

- java.lang.Object
- - net.sourceforge.pmd.AbstractPropertySource
  - - net.sourceforge.pmd.lang.rule.AbstractRule
    - - net.sourceforge.pmd.lang.java.rule.AbstractJavaRule
      - - net.sourceforge.pmd.lang.java.rule.basic.AvoidBranchingStatementAsLastInLoopRule

All Implemented Interfaces:
  JavaParserVisitor, ImmutableLanguage, PropertySource, Rule

    public class AvoidBranchingStatementAsLastInLoopRule
    extends AbstractJavaRule

### Field Summary

Fields
`static EnumeratedMultiProperty<String>` `CHECK_BREAK_LOOP_TYPES`
`static EnumeratedMultiProperty<String>` `CHECK_CONTINUE_LOOP_TYPES`
`static String` `CHECK_DO`
`static String` `CHECK_FOR`
`static EnumeratedMultiProperty<String>` `CHECK_RETURN_LOOP_TYPES`
`static String` `CHECK_WHILE`

### Fields inherited from class net.sourceforge.pmd.AbstractPropertySource

`propertyDescriptors, propertyValuesByDescriptor`

### Fields inherited from interface net.sourceforge.pmd.Rule

`VIOLATION_SUPPRESS_REGEX_DESCRIPTOR, VIOLATION_SUPPRESS_XPATH_DESCRIPTOR`

### Constructor Summary

Constructors
Constructor and Description
`AvoidBranchingStatementAsLastInLoopRule()`

### Method Summary

Methods
`protected Object` `check(EnumeratedMultiProperty<String> property, Node node, Object data)`
`boolean` `checksNothing()`
`String` `dysfunctionReason()` Returns a description of why the receiver may be dysfunctional.
`protected boolean` `hasPropertyValue(EnumeratedMultiProperty<String> property, String value)`
`Object` `visit(ASTBreakStatement node, Object data)`
`Object` `visit(ASTContinueStatement node, Object data)`
`Object` `visit(ASTReturnStatement node, Object data)`

### Methods inherited from class net.sourceforge.pmd.lang.java.rule.AbstractJavaRule

`apply, getDeclaringType, importsPackage, isQualifiedName, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visitAll`

### Methods inherited from class net.sourceforge.pmd.lang.rule.AbstractRule

`addExample, addRuleChainVisit, addRuleChainVisit, addViolation, addViolation, addViolation, addViolationWithMessage, addViolationWithMessage, addViolationWithMessage, deepCopyValuesTo, end, equals, getDescription, getExamples, getExternalInfoUrl, getLanguage, getMaximumLanguageVersion, getMessage, getMinimumLanguageVersion, getName, getParserOptions, getPriority, getRuleChainVisits, getRuleClass, getRuleSetName, getSince, hashCode, isDeprecated, setDeprecated, setDescription, setExternalInfoUrl, setLanguage, setMaximumLanguageVersion, setMessage, setMinimumLanguageVersion, setName, setPriority, setRuleClass, setRuleSetName, setSince, setUsesDFA, setUsesTypeResolution, start, usesDFA, usesRuleChain, usesTypeResolution`

### Methods inherited from class net.sourceforge.pmd.AbstractPropertySource

`copyPropertyDescriptors, copyPropertyValues, definePropertyDescriptor, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.sourceforge.pmd.PropertySource

`definePropertyDescriptor, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Field Detail

#### CHECK_FOR

    public static final String CHECK_FOR

See Also:
  Constant Field Values

#### CHECK_DO

    public static final String CHECK_DO

See Also:
  Constant Field Values

#### CHECK_WHILE

    public static final String CHECK_WHILE

See Also:
  Constant Field Values

#### CHECK_BREAK_LOOP_TYPES

    public static final EnumeratedMultiProperty<String> CHECK_BREAK_LOOP_TYPES

#### CHECK_CONTINUE_LOOP_TYPES

    public static final EnumeratedMultiProperty<String> CHECK_CONTINUE_LOOP_TYPES

#### CHECK_RETURN_LOOP_TYPES

    public static final EnumeratedMultiProperty<String> CHECK_RETURN_LOOP_TYPES

### Constructor Detail

#### AvoidBranchingStatementAsLastInLoopRule

    public AvoidBranchingStatementAsLastInLoopRule()

### Method Detail

#### visit

    public Object visit(ASTBreakStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `AbstractJavaRule`

#### visit

    public Object visit(ASTContinueStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `AbstractJavaRule`

#### visit

    public Object visit(ASTReturnStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `AbstractJavaRule`

#### check

    protected Object check(EnumeratedMultiProperty<String> property,
               Node node,
               Object data)

#### hasPropertyValue

    protected boolean hasPropertyValue(EnumeratedMultiProperty<String> property,
                           String value)

#### checksNothing

    public boolean checksNothing()

#### dysfunctionReason

    public String dysfunctionReason()

Description copied from interface: `PropertySource`
Returns a description of why the receiver may be dysfunctional. Usually due to missing property values or some kind of conflict between values. Returns null if the receiver is ok.

Specified by:
  `dysfunctionReason` in interface `PropertySource`
Overrides:
  `dysfunctionReason` in class `AbstractPropertySource`
Returns:
  String
See Also:
  `PropertySource.dysfunctionReason()`